package jalview.ws.jws2.jabaws2;

import java.util.HashMap;

import compbio.data.msa.JABAService;

import jalview.ws.jws2.AAConClient;
import jalview.ws.jws2.RNAalifoldClient;
import jalview.ws.uimodel.AlignAnalysisUIText;

public class Jws2InstanceFactory
{
  private static HashMap<String, AlignAnalysisUIText> aaConGUI;

  private static void init()
  {
    if (aaConGUI == null)
    {
      aaConGUI = new HashMap<String, AlignAnalysisUIText>();
      aaConGUI.put(compbio.ws.client.Services.AAConWS.toString(),
              AAConClient.getAlignAnalysisUITest());
      aaConGUI.put(compbio.ws.client.Services.RNAalifoldWS.toString(),
              RNAalifoldClient.getAlignAnalysisUITest());
    }
  }

  /**
   * construct a service instance and configure it with any additional
   * properties needed so Jalview can access it correctly
   * 
   * @param jwsservers
   * @param serviceType
   * @param name
   * @param description
   * @param service
   * @return
   */
  public static Jws2Instance newJws2Instance(String jwsservers,
          String serviceType, String name, String description,
          JABAService service)
  {
    init();
    Jws2Instance svc = new Jws2Instance(jwsservers, serviceType, name,
            description, service);
    
    svc.aaui = aaConGUI.get(serviceType.toString());
    return svc;
  }

}
